#!/usr/bin/perl
#use strict;
use warnings;
use Data::Dumper qw(Dumper);
use Config::Tiny;
use Sys::Hostname;
use DateTime;

use Email::Sender::Simple qw(sendmail);
use Email::Simple;
use Email::Simple::Creator;
 
## Globalconfig
my $debug = 1;
my $mailfrom = 'mailprobe@snagview.de';
my $mailto = 'mailprobe@snagview.de';
## End of GLobalconfig

my $exitcode;
my $output;
my $email;
my $subject;
my $host = hostname();

my $dt   = DateTime->now;   # Stores current date and time as datetime object
my $date = $dt->ymd;   # Retrieves date as a string in 'yyyy-mm-dd' format
my $time = $dt->hms;   # Retrieves time as a string in 'hh:mm:ss' format
my $timeDate = "$date $time";

my $filename = shift or die "Usage: $0 filename\n";
open my $fh, '<', $filename or die "Could not open '$filename' $!";


my $config = Config::Tiny->read( $filename );

foreach my $section (keys %{$config}) {
    print "[$section]\n";

    foreach my $parameter (keys %{$config->{$section}}) {
    $exitcode = system("$config->{$section}->{$parameter}");
    $exitcode=($? >> 8);
    $output = `$config->{$section}->{$parameter}`;
        if ($debug == 1) {
                print "\nParameter: $parameter";
                print "\nValue: $config->{$section}->{$parameter}";
                print "\nexitcode: $exitcode";
                print "\noutput: $output";
                print "\n";
                open(my $fh, '>>', '/var/log/sendmailprobes.txt');
                print $fh "$timeDate $subject $exitcode ";
                close $fh;
        }

        $subject="$section;$parameter;$exitcode;$output";
        $email = Email::Simple->create(
         header => [
           To      => $mailto,
           From    => $mailfrom,
           Subject => $subject,
        ],
        body => "Send from Probe $host\n",
        );
        sendmail($email);
        #sendmail($email, { transport => $transport });

    }
}