#!/usr/bin/perl
use strict;
use Mail::IMAPClient;
use IO::Socket;
use IO::Socket::SSL;
use Time::ParseDate;
use Data::Dumper;

##Test
# 
# echo "SNAG-View;MAILPROBE;0;ALLES-OK-DO-NOT-WORRY|time=5s;20;90;;" |/var/lib/nagios/libexec/eventhandlers/send_nsca -H 127.0.0.1 -d ";" -c /etc/nagios/send_nsca.cfg
#

## Config
my $mail_hostname = 'host';
my $mail_username = 'user';
my $mail_password = 'pass';
my $mail_ssl = 1;
my $debug = 1;
my $plugin ='/var/lib/nagios/libexec/eventhandlers/send_nsca -H 127.0.0.1 -d ";" -c /etc/nagios/send_nsca.cfg';
## End of Config

$ENV{'PERL_LWP_SSL_VERIFY_HOSTNAME'} = 0;
$ENV{'SSL_VERIFY_NONE'} = 0;

my $socket = undef;

if ( $mail_ssl ) {
	# Open up a SSL socket to use with IMAPClient later
	$socket = IO::Socket::SSL->new(
		PeerAddr => $mail_hostname,
		PeerPort => 993,
		Timeout => 5,
		SSL_verify_mode => SSL_VERIFY_NONE,
	);
} else {
	# Open up a none SSL socket to use with IMAPClient later
	$socket = IO::Socket::INET->new(
		PeerAddr => $mail_hostname,
		PeerPort => 143,
		Timeout => 5,
	);
}

if ( ! defined( $socket ) ) {
	print STDERR "Could not open socket to mailserver: $@\n";
	exit 1;
}

my $client = Mail::IMAPClient->new(
	Socket   => $socket,
	User     => $mail_username,
	Password => $mail_password,
	Timeout => 5,
);

if ( ! defined( $client ) ) {
	print STDERR "Could not initialize the imap client: $@\n";
	exit 1;
}

if ( $client->IsAuthenticated() ) {
	# Select the INBOX folder
	if ( ! $client->select("INBOX") ) {
		print STDERR "Could not select the INBOX: $@\n";
	} else {
		if ( $client->message_count("INBOX") > 0) {
			if ( $debug = 1 ){ print "Processing " . $client->message_count("INBOX") . " messages....\n"; }
			for( $client->search('ALL') ) {
				if ( $debug = 1 ) { print "   ..." . $_ . "\n"; }
				my $date = $client->date( $_ );
				my $subject = $client->subject( $_ );
				my $body = $client->body_string( $_ );

				my $unix_date = undef;
				if ( $date ) {
					$unix_date = parsedate( $date );
				}

				my $recv_unix = time;

				# Check we have valid stuff
				if ( ! $unix_date || ! $subject || ! $body ) {
					print Dumper( $unix_date );
					print Dumper( $subject );
					print Dumper( $body );
				} else {
					if ( $debug = 1 ) {
						open(my $fh, '>', '/var/log/mailprobe.txt');
						print $fh "$unix_date - subject: $subject";
						close $fh;
					}
					system("echo \"$subject\" | $plugin");
				}

				# Remove the message
				$client->delete_message($_);
			}

			$client->expunge("INBOX");
		} 
		$client->close("INBOX");
	}
} else {
	print STDERR "Could not authenticate against IMAP: $@\n";
	exit 1;
}

$client->done();
exit 0;
